                %title  "Matopas 2: Fontit"
		%subttl "(C) Copyright 1994-1996 Olli and Kalle Niemitalo"


; Matopas 2 (C) Copyright 1994-1996 Olli and Kalle Niemitalo
; Tt peli saa kopioida ja kehitt edelleen; lue KOPIOI.TXT


                include "Matopas2.inc"
                include "MoveZX.mac"
                include "Double.mac"

                include "Fontit.inc"
                include "Tiedosto.inc"

		include "Alloc.inc"

                jumps



                codeseg

;ͻ
; proc LataaFontit                                                            
; Lataa fontit nytlle ja siirt muistiin.                                  
;ͼ
                proc    LataaFontit
                lea     DX, [FontitNimi]
                call    AvaaTiedosto
                jc      @@Ret
                xchg    AX, BX  ; handle bx:n
                mov     CX, 64000
                push    DS ES
                 pop     DS
                 xor     DX, DX
                 mov     AH, 3Fh         ; luetaan sielt nytlle
                 int     21h
                 mov     AH, 3Eh         ; suljetaan se
                 int     21h     ; DS -> nytt
                pop     ES      ; ES -> dataseg
        ; Sitten alkaa armoton bittien vatkaus.
        ; 16*16 merkki, jokainen kooltaan 5*8.
        ; Siirretn merkin vasen laita AX:n siten ett ylin on 2 lsb:ss:
                mov     SI, 321         ; source index
                lea     DI, [Fontit]    ; destination index
                mov     BH, 16 ; rivien mr
@@RiviLoop:     mov     BL, 16 ; merkkien mr rivill
@@MerkkiLoop:   mov     CH, 5  ; merkin leveys
@@LinjaLoop:    xor     AX, AX
                mov     CL, 8  ; merkin korkeus
@@PixelLoop:    or      AL, [DS:SI]        ; luetaan pixeli 0-3
                ror     AX, 2
                add     SI, 320         ; seuraava rivi
                dec     CL
                jnz     @@PixelLoop
                add     SI, 1-8*320     ; seuraava sarake
                dec     CH
                stosw                   ; [ES:DI++] = AX
                jnz     @@LinjaLoop
                inc     SI              ; hyptn rajan yli
                dec     BL
                jnz     @@MerkkiLoop
                add     SI, 9*320-6*16  ; seuraava rivi
                dec     BH
                jnz     @@RiviLoop
                push    DS
                 push    ES
                 pop     DS      ; DS -> dataseg
                pop     ES      ; ES -> nytt
@@Ret:          ret
                endp    LataaFontit

;ͻ
; proc TulostaMerkki                                                          
; Tulostaa yhden merkin kahdella pehmennystasolla.                            
; Sisn: ES:DI=kohdeosoite, AX(ei AL)=merkki - JA D=0 !!!                    
; Sotkee: AX, BX, CX, SI                                                      
; Ulos: DI=osoite merkin oikealla puolella, rako huomioituna                  
;ͼ
                proc    TulostaMerkki
                lea     BX, [Pehmennys]
                fastimul SI, AX, 5*2
                mov     CH, 5   ; saraketta merkiss
                add     SI, offset Fontit
@@SarakeLoop:   mov     CL, 8   ; pixeli sarakkeella
                lodsw           ; Luetaan wordi
@@PixelLoop:    push    AX
                 and     AL, 3
                 jz      @@Seuraava
                 cmp     AL, 3
                 jne     @@Pehmennys
        ; Suora piirto
		 mov	 AL, [Vri]
@@Piirto:        mov     [ES:DI], AL
@@Seuraava:     pop     AX
                add     DI, 320
                shr     AX, 2
                dec     CL
                jnz     @@PixelLoop
                add     DI, 1-8*320
                dec     CH
                jnz     @@SarakeLoop
                inc     DI
                ret
        ; Pehmennetty piirto
@@Pehmennys:    dec     AL
                mov     AL, [ES:DI]
                jz      @@VainYksi      ; jos AL=1 eli tumma
                xlat            ; AL := [DS:BX+AL]
@@VainYksi:     xlat
                jmp     @@Piirto
                endp    TulostaMerkki

;ͻ
; proc TulostaJono                                                            
; Tulostaa nollaan loppuvan merkkijonon kahdella pehmennystasolla.            
; Sisn: DI=kohdeosoite, BP=jonon osoite                                     
; Sotkee: AX, BX, CX, BP, SI                                                  
; Ulos: DI=osoite jonon oikealla puolella, rako huomioituna                   
;       BP=osoite jonon ja nollan jlkeen                                     
;ͼ
                proc    TulostaJono
@@Loop:         MOVEZX  AX, [byte DS:BP]
                inc     BP
                test    AL, AL
                jz      @@Ret
                call    TulostaMerkki
                jmp     @@Loop
@@Ret:          ret
                endp    TulostaJono

;ͻ
; proc TulostaJonoja                                                          
; Tulostaa nollaan loppuvan merkkijonosarjan kahdella pehmennystasolla.       
; Sisn: DI=kohdeosoite, BP=jonon osoite                                     
; Sotkee: AX, BX, CX, BP, SI                                                  
; Ulos: DI=osoite jonon alapuolella, rako huomioituna                         
;       BP=osoite jonojen ja nollan jlkeen                                   
;ͼ
                proc    TulostaJonoja
@@Loop:         cmp     [byte DS:BP], 0
                jz      @@Ret
                push    DI
                 call    TulostaJono
                pop     DI
                add     DI, 9*320
                jmp     @@Loop
@@Ret:          inc     BP
                ret
                endp    TulostaJonoja

;ͻ
; proc AlustaPehmennys                                                        
; Etsii sopivimmat pehmennysvrit.                                            
; Sisn: [Vri]=piirtovri, [A000h:64000]=paletti                            
;ͼ
                proc    AlustaPehmennys
                MOVEZX  AX, [Vri]
                mov     SI, 64000
                add     SI, AX
                add     SI, AX
                add     SI, AX
                mov     BX, [ES:SI]     ; BL=R, BH=G
                mov     DL, [ES:SI+2]   ; DL=B
                inc     BL      ; Kasvatetaan kaikkia kahdella
                inc     BH      ; jotta div saataisiin
                inc     DL      ; "pyristmn ylspin"
                inc     BL
                inc     BH
                inc     DL
                mov     [PiirtoR], BL
                mov     [PiirtoG], BH
                mov     [PiirtoB], DL
        ; Alkutoimet tehty - jatketaan
                mov     SI, 64000
                xor     CX, CX
@@VriLoop:     mov     DH, 3
                MOVEZX  AX, [byte ES:SI+0]
                DOUBLE  AL
                add     AL, [PiirtoR]
                div     DH
                mov     BL, AL  ; BL=ToiveR

                MOVEZX  AX, [byte ES:SI+1]
                DOUBLE  AL
                add     AL, [PiirtoG]
                div     DH
                mov     BH, AL  ; BH=ToiveG

                MOVEZX  AX, [byte ES:SI+2]
                DOUBLE  AL
                add     AL, [PiirtoB]
                div     DH
                mov     DL, AL  ; DL=ToiveB
                mov     [LyhinMatka], 0FFFFh
        ; Etsitn lhin vri
                mov     DI, 64000
                mov     DH, 0           ; DH=ehdokas
@@EtsintLoop:  mov     AL, [ES:DI]     ; Tutkitaan R
                sub     AL, BL
                cbw
                push    DX
                 imul    AX
                 mov     BP, AX
                 mov     AL, [ES:DI+1]   ; Tutkitaan G
                 sub     AL, BH
                 cbw
                 imul    AX
                 add     BP, AX
                 mov     AL, [ES:DI+2]   ; Tutkitaan B
                pop     DX
                sub     AL, DL
                cbw
                push    DX
                 imul    AX
                pop     DX
                add     BP, AX
                cmp     BP, [LyhinMatka]
                jnb     @@EiLyhin
                mov     [LyhinMatka], BP
                mov     [LyhinVari], DH
@@EiLyhin:      add     DI, 3
                inc     DH
                jnz     @@EtsintLoop
                mov     BX, CX
                mov     AL, [LyhinVari]
                mov     [Pehmennys+BX], AL
                add     SI, 3
                inc     CL
                jnz     @@VriLoop
                ret
                endp

                proc    TestaaPehmennys
                mov     [Vri], 56
                xor     DI, DI
@@Loop1:        push    DI
                 call    AlustaPehmennys
                pop     DI
                mov     CX, 256
                lea     SI, [Pehmennys]
@@Loop2:        rep     movsb
                add     DI, 320-256
                inc     [Vri]
                jne     @@Loop1
                mov     [Vri], 15
                jmp     AlustaPehmennys
                endp    TestaaPehmennys



                const

FontitNimi      db      "FntSmall.mpd", 0



		udataseg

Fontit		dw	256*5 dup (?)

LyhinMatka	dw	?
LyhinVari	db	?

Pehmennys	db	256 dup (?)

PiirtoR 	db	?
PiirtoG 	db	?
PiirtoB 	db	?



		zdataseg

Vri		db	?



                end
