                %title  "Matopas 2: Kellokeskeytys IRQ0"
		%subttl "(C) Copyright 1994-1996 Olli and Kalle Niemitalo"


; Matopas 2 (C) Copyright 1994-1996 Olli and Kalle Niemitalo
; Tt peli saa kopioida ja kehitt edelleen; lue KOPIOI.TXT


                include "Matopas2.inc"
                include "Seg.mac"

                include "Matopas2.typ"

                include "Kello.inc"
                include "Sfx.inc"
                include "Tilanne.inc"   ; AikaPelaajasta, AikaTimantista

		include "Alloc.inc"

SAIRAS		=	FALSE	; Vlkytt Turboa Hyundai Super-386S/20L:ll



                segment Nollasegmentti  at 0000

                org     08h*4
Vektori08       F_FAR   ?

                ends



                codeseg

                proc    AvaaKello
                xor     DX, DX
                cmp     [word high Vanha08Handleri], DX
                jnz     @@Ret ; jos segmentti ei ollut nolla -> jo asennettu
                pushf
                 push    DS
                  mov     DS, DX
                  assume  DS:Nollasegmentti
                  cli
        if @Cpu and 08h ;386+
                  db      66h, 0B8h     ; mov EAX, imm32
                  F_FAR   Kellokeskeytys
                  xchg    EAX, [Vektori08]
                  mov     [Vanha08Handleri], EAX
        else ;286-
                  lea     AX, [Kellokeskeytys]
                  xchg    AX, [word low Vektori08]
                  mov     [word low Vanha08Handleri], AX
                  mov     AX, CS
                  xchg    AX, [word high Vektori08]
                  mov     [word high Vanha08Handleri], AX
        endif ;386+/286-
        ; alustetaan timer 0 sopivaksi (ripattu HelpPC:st)
                  mov     AL, 00110110b  ; bit 7,6 = (00) timer counter 0
                                         ; bit 5,4 = (11) write LSB then MSB
                                         ; bit 3-1 = (011) generate square wave
                                         ; bit 0 = (0) binary counter
                  out     43h, AL ; prep PIT, counter 0, square wave&init count
                  jmp     $+2
                 pop     DS
                 assume  DS:@data
                 mov     AL, [byte low TahtiNyt]
                 out     40h, AL
                 jmp     $+2
                 mov     AL, [byte high TahtiNyt]
                 out     40h, AL
                 jmp     $+2
                popf
@@Ret:          ret
                endp    AvaaKello

                proc    SuljeKello
                pushf
        if @Cpu and 08h ;386+
                 xor     EAX, EAX
                 cli
                 xchg    EAX, [Vanha08Handleri]
                 test    EAX, EAX
                 jz      @@PopfRet ; ei ollutkaan asennettu
                 push    DS
                  MOVSEG  DS, 0, BX     ; BX:n tai pinon kautta
                  assume  DS:Nollasegmentti
                  mov     [Vektori08], EAX
        else
                 xor     AX, AX
                 cli
                 xchg    AX, [word high Vanha08Handleri]
                 test    AX, AX
                 jz      @@PopfRet ; ei ollutkaan asennettu
                 push    DS
                  xor     DX, DX  ; kytetn mys XCHG:ssa
                  mov     DS, DX
                  assume  DS:Nollasegmentti
                  mov     [word high Vektori08], AX
                  xchg    [word low Vanha08Handleri], DX
                  mov     [word low Vektori08], DX
        endif
                 pop     DS
                 assume  DS:@data
        ; palautetaan timer 0
                 mov     AL, 00110110b  ; bit 7,6 = (00) timer counter 0
                                        ; bit 5,4 = (11) write LSB then MSB
                                        ; bit 3-1 = (011) generate square wave
                                        ; bit 0 = (0) binary counter
                 out     43h, AL ; prep PIT, counter 0, square wave&init count
                 jmp     $+2
                 xor     AX, AX
                 out     40h, AL
                 jmp     $+2
                 out     40h, AL
                 jmp     $+2
        ; vaiennetaan net
                 call    [SfxLopetus]
@@PopfRet:      popf
                ret
                endp    SuljeKello

                proc    Kellokeskeytys  far     ;interrupt 08h
        if @Cpu and 02h ;188+ jolla pusha/popa toimii
                pusha
        else ;8086- jolla ei toimi
                push    AX
        endif ;188+/8086-
                 push    DS
	if SAIRAS
		  push	  CS
		  push	  offset @Jatkuu
		  push	  3861h
		  mov	  AL, [byte Kehyslaskuri]
		  shr	  AL, 3
		  and	  AL, 01h
		  jmp	  far (0F000h:537Eh)
@Jatkuu:
	endif
                  cld   ; liput pushautuneet automaattisesti
                  SETUPDS
        if @Cpu and 02h ;188+ jolla pusha toimii
                  call    [SfxKeskeytys]   ; kaikki jo pushattu
        else ;8086- jolla pusha ei toimi
                  push    BX CX DX SI DI BP
                       call    [SfxKeskeytys]
                  pop     BP DI SI DS CX BX
        endif ;188+/8086-
                  mov     AX, [TahtiNyt]
                  inc     [Askellaskuri]
                  inc     [Kehyslaskuri]
                  inc     [AikaPelaajasta]
                  inc     [AikaTimantista]
                  add     [Tahdistus], AX
                 pop     DS
                 assume  DS:nothing
                 jc      @@KutsuVanha
                 mov     AL, 20h        ; Non-Specific End Of Interrupt
                 out     20h, AL
        if @Cpu and 02h ;188+ jolla pusha/popa toimii
                popa
        else ;8086- jolla ei toimi
                pop     AX
        endif ;188+/8086-
                iret
        if @Cpu and 02h ;188+ jolla pusha/popa toimii
@@KutsuVanha:   popa
        else ;8086- jolla ei toimi
@@KutsuVanha:   pop     AX
        endif ;188+/8086-
                db      0EAh    ; jmp far
Vanha08Handleri F_FAR   0
                endp    Kellokeskeytys



		zdataseg

Askellaskuri	dw	?
Kehyslaskuri	dw	?
Tahdistus	dw	?



                dataseg

TahtiNyt        dw      7000



                end
