program Mpd2Bki;

  const
    Versio = 'Mpd2Bki (Matopas 2) 2.3';

  var
    Kuva: array[0..199, 0..319] of Byte;

  procedure LueMpd(MpdTiedNimi: string);
    var
      MpdTied: file;
    begin
      WriteLn('Luen tiedostoa ', MpdTiedNimi, ' ...');
      Assign(MpdTied, MpdTiedNimi);
      Reset(MpdTied, 1);
      if FileSize(MpdTied) <> 64000 then begin
        WriteLn('Tiedosto on vrn kokoinen (', FileSize(MpdTied),
                '), pitisi olla 64000.');
        Close(MpdTied);
        Halt(1)
      end;
      BlockRead(MpdTied, Kuva, SizeOf(Kuva));
      Close(MpdTied)
    end;

  procedure KirjoitaTasaten(var Kohde: Text; Jono: string);
    begin
      Write(Kohde, Jono);
      case Length(Jono) of
	0..6 : Write(Kohde, #9#9);
	7    : Write(Kohde, ' '#9);
	8..14: Write(Kohde, #9)
	else   Write(Kohde, ' ')
      end
    end;

  procedure KirjoitaBki(BkgNimi, BkiTiedNimi: string);
    var
      BkiTied: Text;
    procedure TallennaPala(Nimi: string; Numero: Integer;
			   Vasen, Huippu, Leveys, Korkeus, Siirros: Word);
      var
	NumeroTekstina, PalanNimi: string;
	X, Y, Lukuja: Word;
      begin
	Str(Numero, NumeroTekstina);
	PalanNimi := Nimi + '_' + NumeroTekstina;
	KirjoitaTasaten(BkiTied, PalanNimi);
	WriteLn(BkiTied, 'BKG',
		#9'<', Siirros, ', ', Leveys, ', ', Korkeus, '>',
		#9'; (', Vasen, ',', Huippu, ')');
	for Y := Huippu to Huippu+Korkeus-1 do begin
	  Write(BkiTied, #9#9'db'#9);
	  Lukuja := 0;
	  for X := Vasen to Vasen+Leveys-1 do begin
	    if Lukuja > 100 then begin
	      WriteLn(BkiTied);
	      Write(BkiTied, #9#9'db'#9#9);
	      Lukuja := 0
	    end;
	    if Lukuja > 0 then
	      Write(BkiTied, ',');
	    Write(BkiTied, Kuva[Y, X]);
	    Inc(Lukuja)
	  end;
	  WriteLn(BkiTied)
	end
      end;
    var
      Vasen, Oikea, Siirros, Huippu, Pohja, Alin: Word;
      Numero: Integer;
    begin
      WriteLn('Kirjoitan tiedostoa ', BkiTiedNimi, ' ...');
      Assign(BkiTied, BkiTiedNimi);
      Rewrite(BkiTied);
      WriteLn(BkiTied, '; Tmn tiedoston teki ' + Versio);
      WriteLn(BkiTied);

      Huippu := 0;
      Alin := 0;
      Numero := 0;

      while (Huippu < 199) and (Kuva[Huippu, 0] <> 15) do begin
        Vasen := 0;
        while (Vasen < 320) and (Kuva[Huippu, Vasen] <> 15) do begin
          Oikea := Vasen;
          while (Oikea < 320) and (Kuva[Huippu, Oikea] <> 15) do
            Inc(Oikea);
          if (Oikea > 319) and (Vasen > 0) then begin
            WriteLn;
            WriteLn('Lohko jatkuu oikeaan reunaan asti vaikka ei ala vasemmasta!');
            WriteLn('Jos kyseess ei ole virhe, siirr lohko alemmas vasempaan reunaan.');
	    Close(BkiTied);
            Halt(2)
          end;
          Pohja := Huippu;
          while (Pohja < 200) and (Kuva[Pohja, Vasen] <> 15) do
            Inc(Pohja);
          if Pohja > Alin then
            Alin := Pohja;
          Siirros := 0;
          while Kuva[Pohja, Oikea-1-Siirros] <> 15 do
            Inc(Siirros);
	  Inc(Numero);
	  TallennaPala(BkgNimi, Numero,
		       Vasen, Huippu, Oikea-Vasen, Pohja-Huippu,
		       Siirros);
          Vasen := Oikea + 1
        end;
        Huippu := Alin + 1
      end;

      Close(BkiTied);
      WriteLn('Valmis.')
    end;

  begin
    WriteLn(Versio);
    if ParamCount <> 1 then begin
      WriteLn('Anna yksi parametri: .mpd-tiedoston nimi ilman ptett.');
      Halt(1)
    end;
    LueMpd(ParamStr(1)+'.mpd');
    KirjoitaBki(ParamStr(1), ParamStr(1)+'.bki')
  end

.
