                %title  "Matopas 2: Fraktaalit ToD-mainoksesta"
		%subttl "(C) Copyright 1994-1996 Olli and Kalle Niemitalo"


; Matopas 2 (C) Copyright 1994-1996 Olli and Kalle Niemitalo
; Tt peli saa kopioida ja kehitt edelleen; lue KOPIOI.TXT


                include "Matopas2.inc"
                include "Rnd.mac"

                include "Temple.inc"
                include "Ohjelma.inc"   ; RandSeed
                include "Kello.inc"

                include "Alloc.inc"

                jumps



                struc   SCALERS
MaxWord         dw      ?
XToX            dw      ?
YToX            dw      ?
AddX            dw      ?
XToY            dw      ?
YToY            dw      ?
AddY            dw      ?
                ends    SCALERS



RND_CONST       =       9621

TIMER_INT       =       08h     ; IRQ 0
TIMER_OFS       =       TIMER_INT*4

TIMER_BASE      =       1193180 ; Hz
TIMER_VALUE     =       TIMER_BASE / 70 - 100   ; leave time for sync

X_SCALE         =       8
Y_SCALE         =       8

SCR_WIDTH       =       320
SCR_HEIGHT      =       200

EMPTY_COLOR     =       0       ; 0 = speed
MIN_IFS_COLOR   =       1       ; other than 1 would require some changes
MIN_FORE_COLOR  =       200     ;* 65 won't be drawn on

DELAY           =       16      ; how many frames to show dots for -- power of 2

MAX_NEW_BYTES   =       65536/DELAY

DEBUG_TO64000   =       0       ; Fill the buffer with 64000? Not vital
DEBUG_CLEAR	=	0	; Clear the screen with color #0?
DEBUG_LINE      =       0       ; Draw a line of colors? Only for debugging
DEBUG_NOP       =       0       ; Add extra NOPs? Of course not
DEBUG_DRAW      =       1       ; Draw anything at all?
DEBUG_RUB       =       1       ; Rub anything at all? Who likes garbage
DEBUG_CHKRUB    =       1       ; Rub only pixels of the right color? You decide
DEBUG_CHKFORE   =       1       ; Prevent drawing on the foreground image? Sure
DEBUG_CHKTIME   =       1       ; Stop drawing on vertical retrace? Better so
DEBUG_CALLOLD   =       1       ; Call the old timer routine? or crash :)
DEBUG_EXTRN0    =       1       ; Are most variables external?
DEBUG_MOVE      =       0       ; Animate the picture?
DEBUG_CONTROL   =       1       ; Allow moving with a mouse and the keyboard?
DEBUG_SHOWLIMIT =       0       ; Flash colors when the pixel limit is hit?
DEBUG_KILLINTR  =       0       ; Prevent interrupts other than IRQ0 (clock)?



                codeseg

                proc    TempleMain
                mov     [BufferSeg], Buffer  ; relocation item here
if DEBUG_CLEAR
                xor     DI, DI
                xor     AX, AX
                mov     CX, 32000
                rep     stosw
endif

if DEBUG_LINE
                mov     BX, 00FFh
LineLoop:       mov     [ES:BX], BL
                dec     BX
                jnz     LineLoop
endif

        ; Initialize the color array.
                push    DS
                 xor     AX, AX
                pop     ES                  ; !!! ES NO LONGER IS 0A000H !!!
                mov     CX, 2*DELAY
                mov     DI, offset ColorArray
                xor     BX, BX
ColorInitLoop:  stosw           ; R=00 G=00
                xchg    BX, AX
                stosb           ; B=xx
                xchg    BX, AX
if DELAY eq 64
                inc     BX
elseif DELAY ge 32
                inc     BX
                inc     BX
else
                add     BX, 64/DELAY
endif
                loop    ColorInitLoop
                mov     [byte ColorArray+(DELAY-1)*3+1], 15    ; glitter

if DEBUG_TO64000
                mov     ES, [BufferSeg] ; clear the area
                mov     AX, 64000
                xor     DI, DI
                mov     CX, 32768
                rep     stosw   ; direction flag is already 0
endif

        ; Clear the mouse motion counters.
                mov     AX, 000Bh       ; Read Motion Counters
                int     33h             ; -> (CX, DX)

        ; Kill Matopas 2 timer system.
                call    SuljeKello

        ; Install the timer interrupt handler.
                cli
                push    0
                pop     ES
                mov     AX, offset TimerHandler
                mov     BX, CS
                xchg    [word ES:TIMER_OFS+0], AX
                xchg    [word ES:TIMER_OFS+2], BX
                mov     [word low OldTimerHandler], AX
                mov     [word high OldTimerHandler], BX
                sti

        ; Change the speed of the timer.
                call    SetTimer

if DEBUG_KILLINTR
        ; Disable everything except the timer.
                in      AL, 21h
                xchg    [OldPort21], AL
                out     21h, AL
endif

        ; Add a few NOPs to help you find the loop?
ifdef DEBUG_NOP
                nop
                nop
endif

        ; Get the next color.
errif MIN_IFS_COLOR ne 1 <CurrentColor advancing system must be rewritten!!>

FrameLoop:      mov     AX, [CurrentColor]
                and     AL, DELAY-1
                inc     AX      ; AH will never become 1
                mov     [CurrentColor], AX

        ; Cycle the palette.
if DEBUG_RUB
                mov     BX, AX  ; store for rubbing
endif
                mov     SI, offset ColorArray + 3*DELAY
                mov     DX, 03C8h
                sub     SI, AX
                mov     CX, 3*DELAY
                sub     SI, AX
                sub     SI, AX
                mov     AL, MIN_IFS_COLOR
                out     DX, AL
                inc     DX
                rep     outsb   ; from [DS:SI] to port DX

        ; Rub out the previous pixels.
if DEBUG_RUB
                mov     DI, BX  ;=[CurrentColor]
                add     DI, DI
                mov     CX, [Drawn + DI - 2*MIN_IFS_COLOR]
                mov     DX, 0A000h
                jcxz    short NothingToRub
                push    DI
                 les     SI, [dword RubPtr]     ; ES points to the buffer
                 push    DS
                  mov     DS, DX                ; DS points to the screen
RubLoop:          lods    [word ES:SI]          ; get address (D=0)
                  mov     DI, AX
 if DEBUG_CHKRUB
                  cmp     [DS:DI], BL   ; wrong color?
                  jne     short DontRub
 endif
 if EMPTY_COLOR
                  mov     [DS:DI], EMPTY_COLOR
 else
                  mov     [DS:DI], DL   ;=0 as DX=0A000h
 endif
DontRub:          loop    RubLoop
                 pop     DS
                pop     DI              ; [CurrentColor]*2, index of Drawn
                mov     [RubPtr], SI
                mov     [Drawn + DI - 2*MIN_IFS_COLOR], 0
NothingToRub:
endif

        ; Initialize some registers & a memory location for IFS drawing.
                mov     DI, [DrawPtr]
                mov     BP, [BufferSeg]
                lea     AX, [DI + MAX_NEW_BYTES]
                mov     [MaxDrawPtr], AX

        ; Select a "random" number.
IFSLoop:        RND     AX
                mov     SI, offset IfsData - size SCALERS

        ; Find the scalers to use.
ScalerLoop:     add     SI, size SCALERS
                cmp     AX, [(SCALERS SI).MaxWord]
                ja      ScalerLoop

        ; Calculate the new coordinates.
Advance:        mov     AX, [X]
                imul    [(SCALERS SI).XToX]
                mov     BX, DX
                mov     AX, [Y]
                imul    [(SCALERS SI).YToX]
                add     BX, DX
                add     BX, [(SCALERS SI).AddX]
                mov     AX, [X]
                imul    [(SCALERS SI).XToY]
                mov     CX, DX
                mov     AX, [Y]
                imul    [(SCALERS SI).YToY]
                add     CX, DX
                add     CX, [(SCALERS SI).AddY]
                add     BX, BX
                add     CX, CX
                mov     [X], BX
                mov     [Y], CX

        ; Draw & save the point if the coordinates and the old color are valid.
                xchg    AX, CX          ; CX was Y (but no longer is)
                sar     AX, Y_SCALE
                add     AX, SCR_HEIGHT/2
if (8000h shr Y_SCALE) ge (SCR_HEIGHT/2)
                cmp     AX, SCR_HEIGHT
                jae     short DontDraw
endif
                sar     BX, X_SCALE     ; BX was X
                mov     DX, SCR_WIDTH
                add     BX, SCR_WIDTH/2
if (8000h shr X_SCALE) ge (SCR_WIDTH/2)
                cmp     BX, DX
                jae     short DontDraw
endif
                mul     DX              ; DX=SCR_WIDTH
                push    0A000h  ; going to ES
                 add     BX, AX
                pop     ES
                mov     AL, [byte CurrentColor]
if DEBUG_CHKFORE
                cmp     [byte ES:BX], MIN_FORE_COLOR
                jae     short DontDraw
endif
if DEBUG_DRAW
                mov     [ES:BX], AL
endif
                mov     ES, BP          ; BP=BufferSeg
                xchg    AX, BX
                stosw                   ; store the address, D=0
DontDraw:

        ; Any time left to draw another point?
if DEBUG_CHKTIME
                cmp     [VerticalHit], 0
                jnz     short OutOfTime
endif

        ; Is it allowed to draw more?
                db      81h, 0FFh       ; cmp DI, xxxx
MaxDrawPtr      dw      ?
                jne     IFSLoop
if DEBUG_SHOWLIMIT
                inc     [ColorArray + 3*(DELAY-1)]     ; red
endif
OutOfTime:

        ; Save the amount of pixels drawn.
                xchg    AX, DI          ; AX=new bytes
                mov     CX, [DrawPtr]   ; CX=old bytes
                mov     [DrawPtr], AX
                mov     BX, [CurrentColor]
                sub     AX, CX          ; AX=new-old bytes
                add     BX, BX
                shr     AX, 1           ; AX=new-old pixels
                mov     [Drawn + BX - 2*MIN_IFS_COLOR], AX      ; save it

        ; Set up the next frame - music etc would come here
if DEBUG_MOVE
                sub     [(IfsData + size SCALERS).XToY], 10
                add     [(IfsData + size SCALERS).YToX], 7
                dec     [(IfsData + size SCALERS).YToY]
endif
if DEBUG_CONTROL
                mov     AX, 0003h       ; Read Buttons & Location
                int     33h             ; -> BX, (CX, DX)
                mov     AX, 000Bh       ; Read Motion Counters
                int     33h             ; -> (CX, DX)
                mov     DI, [ScalerPtr]
                testflag BX, 4   ; middle button
                jnz     MouseMidDone
                shl     CX, 4
                shl     DX, 4
MouseMidDone:   shr     BX, 1   ; left mb to carry
                jc      MouseLeftDown
                shr     BX, 1   ; right mb to carry
                jc      MouseRightDown
                add     [(SCALERS DI).AddX], CX
                add     [(SCALERS DI).AddY], DX
                jmp     MouseDone
MouseLeftDown:  add     [(SCALERS DI).XToX], CX
                add     [(SCALERS DI).XToY], DX
                jmp     MouseDone
MouseRightDown: add     [(SCALERS DI).YToX], CX
                add     [(SCALERS DI).YToY], DX
MouseDone:
endif

        ; Wait for it (note that IFS may be stopped by the pixel limit)
FrameDelay:     mov     DX, 03DAh
                in      AL, 60h
                dec     AL    ; test ESC and convert to number
                jz      short EscHit
if DEBUG_CONTROL
                mov     DI, [ScalerPtr]
                cmp     AL, 80h+34h-1 ; period released - clears multipliers
                jne     NotPeriod
                mov     [(SCALERS DI).XToX], 0
                mov     [(SCALERS DI).XToY], 0
                mov     [(SCALERS DI).YToX], 0
                mov     [(SCALERS DI).YToY], 0
NotPeriod:      cmp     AL, 80h+13h-1 ; R released - rotates 90 clockwise
                jne     NotBackslash
                mov     AX, [(SCALERS DI).XToX]
                xchg    AX, [(SCALERS DI).XToY]
                neg     AX
                mov     [(SCALERS DI).XToX], AX
                mov     AX, [(SCALERS DI).YToX]
                xchg    AX, [(SCALERS DI).YToY]
                neg     AX
                mov     [(SCALERS DI).YToX], AX
NotBackslash:   cmp     AL, 10 ; numbers - select scalers to change
                ja      NotANumber
                mov     AH, size SCALERS
                mul     AH
                add     AX, offset IfsData - size SCALERS
                mov     [ScalerPtr], AX
NotANumber:
endif
                in      AL, DX
                test    AL, 08h
                jz      FrameDelay
                mov     [byte VerticalHit], 0
                call    SetTimer
                jmp     FrameLoop
EscHit:

        ; Restore the timer speed.
                xor     BX, BX
                call    SetTimerToBX

if DEBUG_KILLINTR
        ; Let the interrupts rule again.
                mov     AL, [OldPort21]
                out     21h, AL
endif

        ; Uninstall the timer interrupt handler.
                xor     AX, AX
                les     BX, [OldTimerHandler]
                push    DS
                 mov     DS, AX
                 cli
                 mov     [DS:TIMER_OFS + 0], BX
                 mov     [DS:TIMER_OFS + 2], ES
                 sti
                pop     DS

        ; Reinstall Matopas 2 timer system.
                call    AvaaKello

        ; Restore Matopas 2 colors.
                mov     AX, 0A000h
                mov     ES, AX
                mov     DX, 03C8h
                mov     AX, 0100h
                mov     SI, 64000
                out     DX, AL
                inc     DX
                xchg    CX, AX
                rep     outs    DX, [byte ES:SI]

        ; Then return.
                ret
                endp    TempleMain

;ͻ;
;                       A SUBROUTINE TO SET THE TIMER                        ;
;ͼ;

                proc    SetTimer        near
                mov     BX, TIMER_VALUE
SetTimerToBX:   pushf
                 cli
                 mov     AL, 36h
                 out     43h, AL
                 mov     AL, BL
                 out     40h, AL
                 mov     AL, BH
                 out     40h, AL
                popf
                ret
                endp    SetTimer

;ͻ;
;                            THE SAVED DATA AREA                             ;
;ͼ;
; All constants and non-zero-initialized variables are stored here.

                dataseg

ScalerPtr       dw      IfsData
                include "fract.wcf"
                SCALERS 10 dup (<>)

if DEBUG_KILLINTR
OldPort21       db      0FEh
endif

;ͻ;
;                       THE VERTICAL INTERRUPT HANDLER                       ;
;ͼ;

                codeseg

                proc    TimerHandler
                push    AX              ; Save the registers altered.

                 inc     [CS:VerticalHit]; (note explicit CS)


if DEBUG_CALLOLD
                 mov     AL, 20h
                 out     20h, AL
endif

                pop     AX              ; Restore the registers.

if DEBUG_CALLOLD
                db      0EAh            ; jmp far
else
                iret
endif
OldTimerHandler dd      ?
                endp    TimerHandler

;ͻ;
;                       THE ZERO-INITIALIZED DATA AREA                       ;
;ͼ;

		zdataseg

X               dw      ?
Y               dw      ?
CurrentColor    dw      ?       ; the higher byte is always 0
DrawPtr         dw      ?
Drawn           dw      DELAY dup (?)
VerticalHit     db      ?

RubPtr          dw      ?
BufferSeg       dw      ?       ; should be directly after RubPtr (LDS used)

ColorArray      db      2*DELAY dup (?, ?, ?)

;ͻ;
;                      THE CIRCULAR DOT-ADDRESS BUFFER                       ;
;ͼ;

                ufardata Buffer

                dw      32768 dup (?)



                end
